;;;========================================================================
;;;
;;;  LAYBLK.LSP version 1.00 (c) Christopher Lovelock - 17 February 1995
;;;  SysOp of CADenza BBS +44(0) 533 596725 U.K.
;;;  PCGnet 9:526/725
;;;  FidoNet 2:2503/308
;;;  CompuServe 100111,2200
;;;
;;;  This routine is used to update the block FRAME in BSLAYERS.DWG to:
;;;
;;;  1. Change the attribute called LAYER in the block to the layer name
;;;  that the block is in.
;;;
;;;  2. Check ALIAS.DAT file for an alias that matches the layer name,
;;;  if found update the attribute called ALIAS with the alias text.
;;;
;;;========================================================================

(if (not alias)
   (load "ALIAS.DAT")
) 

(if (tblsearch "block" "FRAME" t)
   (progn
      (princ "\nSearching for FRAME block(s)... ")
      (if (setq a (ssget "x" '((2 . "FRAME"))))
         (progn
            (setq n (sslength a))
            (while (> n 0) 
               (setq n (- n 1) 
                     ent (ssname a n) 
                     lay (cdr (assoc 8 (entget ent)))
                     sub (entnext ent)
               )
               (while sub 
                  (setq lis (entget sub))
                  (cond
                     ((and (= (cdr (assoc 0 lis)) "ATTRIB") 
                         (= (cdr (assoc 2 lis)) "LAYER")
                      ) 
                      (setq lis (subst (cons 1 lay) (assoc 1 lis) lis))
                      (entmod lis)
                     )
                  ) 
                  (cond
                     ((and (= (cdr (assoc 0 lis)) "ATTRIB") 
                         (= (cdr (assoc 2 lis)) "ALIAS")
                      )
                      (if (cadr (assoc (substr lay 2 3) alias))
                         (setq lis (subst (cons 1 (cadr (assoc (substr lay 2 3) alias))) (assoc 1 lis) lis))
                         (setq lis (subst (cons 1 lay) (assoc 1 lis) lis))
                      )
                      (entmod lis)
                     )
                  ) 
                  (if (= (cdr (assoc 0 lis)) "SEQEND") 
                     (setq sub nil)
                     (setq sub (entnext sub))
                  )
               ) 
               (princ "\nRedrawing block") 
               (entupd ent)
            )
         ) 
         (progn
            (write-char 7) 
            (princ "FRAME in block listing but not inserted! ")
         )
      )
   ) 
   (progn
      (write-char 7) 
      (princ "There is no FRAME block in this drawing?!! ")
   )
) 
(princ) 

